// 002 u_i_genc_037_generic_interface
// 24 feb 2008

// -- (C) Felix John COLIBRI 2008
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_i_genc_037_generic_interface;
  interface

    type i_visitor<T_node>= Interface
                              procedure Visit(p_node: T_node);
                            end; // i_visitor

         c_point<T_data>= Class
                            m_x, m_y: T_data;

                            constructor create_point(p_x, p_y: T_data);
                            function ToString: String; Override;
                            procedure Accept(p_c_visitor: i_visitor< c_point<T_data> > );
                          end; // c_point

         c_display_visitor<T_node>= Class(tObject, i_visitor<T_node>)
                                      procedure Visit(p_node: T_node);
                                    end; // c_display_visitor

  implementation

    // -- c_point<T_data>

    constructor c_point<T_data>.create_point(p_x, p_y: T_data);
      begin
        Inherited Create;
        m_x:= p_x; m_y:= p_y;
      end; // create_point

    procedure c_point<T_data>.Accept(p_c_visitor: i_visitor< c_point<T_data> > );
      begin
        p_c_visitor.Visit(Self);
      end; // Accept

    function c_point<T_data>.ToString: String;
      begin
        writeln('x=', m_x.ToString+ ', y=' + m_y.ToString);
      end; // ToString

     // -- c_display_visitor<T_node>

     procedure c_display_visitor<T_node>.Visit(p_node: T_node);
       begin
         writeln(p_node.ToString);
       end; // Visit

    end. // u_i_genc_037_generic_interface_5


